//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//
#include "Kostka_full.h"

Kostka_full::Kostka_full()
{
    m_poslHod= NULL;
    m_pocHodu= 0;
    srand(time(NULL));

    //inicializace vektoru
    std::vector<int> pom;
    m_vectHodu.push_back(pom);
}

int Kostka_full::hodKostkou(bool noveKolo){
    int hod= randFce(6);
    m_pocHodu++;
    m_poslHod= hod;

    if (noveKolo){  //nove kolo
        std::vector<int> pom;
        pom.push_back(hod);
        m_vectHodu.push_back(pom);
    } else {    //soucasne kolo
        m_vectHodu[(m_vectHodu.size()-1)].push_back(hod);
    }
    return hod;
}

int Kostka_full::hodKostkou(bool noveKolo, int pocetHran){
    int hod= randFce(pocetHran);
    m_pocHodu++;
    m_poslHod= hod;

    if (noveKolo){  //nove kolo
        std::vector<int> pom;
        pom.push_back(hod);
        m_vectHodu.push_back(pom);
    } else {    //soucasne kolo
        m_vectHodu[(m_vectHodu.size()-1)].push_back(hod);
    }
    return hod;
}

int Kostka_full::opakujHod(){
    int hod= randFce(6);
    m_poslHod= hod;
    m_vectHodu.back().push_back(hod);
    return hod;
}

void Kostka_full::prazdnyHod(){
    m_poslHod= 0;
    m_vectHodu.back().push_back(0);
}

int Kostka_full::vratPosledniHodVect(){
    return m_vectHodu.back().back();
}

int Kostka_full::vratPocetKolVect(){
    return m_vectHodu.size();
}

int Kostka_full::vratPocetHoduVect(int kolo){
    if (m_vectHodu.size()>kolo && (kolo)>=0)
        return m_vectHodu[kolo].size();
}

int Kostka_full::vratKonkretniHod(int kolo, int hod){
    if (m_vectHodu.size()>kolo && kolo>=0){
        if (m_vectHodu[kolo].size()>=hod && hod>=0)
            return m_vectHodu[kolo][hod];
    }
}

void Kostka_full::vypisHodyVse(){
    for(int i=0; i<m_vectHodu.size(); i++){
            std::cout<<"Kolo "<<i+1<<std::endl;
        for(int j=0; j<m_vectHodu[i].size(); j++){
            std::cout<<m_vectHodu[i][j]<<std::endl;
        }
    }
}

void Kostka_full::vypisHodyPodleKola(int kolo){
    if (kolo>=1 && kolo<=m_vectHodu.size()){
        std::cout<<"Kolo "<<kolo<<std::endl;
        for(int i=0; i<m_vectHodu[kolo-1].size(); i++)
            std::cout<<m_vectHodu[kolo-1][i]<<std::endl;
    } else {
        std::cout<<"spatny pocet kol";
    }
}
